#include <FastLED.h>

#define LED_PIN 3
#define NUM_LEDS 56
#define BRIGHTNESS 256
#define LED_TYPE WS2811
#define COLOR_ORDER BRG
CRGB leds[NUM_LEDS];
CRGB ledColor;

int player1 = 1;
int player2 = 10;
CRGB playerColor1 = CRGB::Green;
CRGB playerColor2 = CRGB::Yellow;
int player = player1;
int selectedColumn = 3;
// const int rightPinBtn  = A0;
const int rightPinBtn = 13;
const int leftPinBtn = 12;
const int btnValidPin = 11;

// Variables
int btnVal = 0;
bool btnState = false;
bool oldbtnState = false;

int mapArray[7][6] = {
    {48, 47, 46, 45, 44, 43},
    {37, 38, 39, 40, 41, 42},
    {36, 35, 34, 33, 32, 31},
    {25, 26, 27, 28, 29, 30},
    {24, 23, 22, 21, 20, 19},
    {13, 14, 15, 16, 17, 18},
    {12, 11, 10, 9, 8, 7},
};
int gameArray[7][6] = {
    {0, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0},
};

void setup()
{

    Serial.begin(9600);
    FastLED.addLeds<NEOPIXEL, LED_PIN>(leds, NUM_LEDS);

    Serial.println(F("Initialize System"));
    // Init btn
    pinMode(rightPinBtn, INPUT_PULLUP);
    pinMode(leftPinBtn, INPUT_PULLUP);
    pinMode(btnValidPin, INPUT_PULLUP);
    reset();
}

void loop()
{

    colorChoice();

    display_pending_pawn();

    affice_tableau_jeu();

    listenButton();

    winCheck();
}

void winCheck()
{

    // check if there is a line
    for (int col = 0; col < 4; col++)
    {
        for (int ligne = 0; ligne < 6; ligne++)
        {
            if (gameArray[col][ligne] != 0)
            {
                int somme = gameArray[col][ligne] + gameArray[col + 1][ligne] + gameArray[col + 2][ligne] + gameArray[col + 3][ligne];
                if (somme == 4)
                {

                    while (digitalRead(btnValidPin))
                    {
                        leds[mapArray[col][ligne]] = playerColor1;
                        leds[mapArray[col + 1][ligne]] = playerColor1;
                        leds[mapArray[col + 2][ligne]] = playerColor1;
                        leds[mapArray[col + 3][ligne]] = playerColor1;
                        FastLED.show();
                        delay(500);
                        leds[mapArray[col][ligne]] = CRGB::Black;
                        leds[mapArray[col + 1][ligne]] = CRGB::Black;
                        leds[mapArray[col + 2][ligne]] = CRGB::Black;
                        leds[mapArray[col + 3][ligne]] = CRGB::Black;
                        FastLED.show();
                        delay(500);
                    }

                    reset();
                }
                else if (somme == 40)
                {
                    while (digitalRead(btnValidPin))
                    {
                        leds[mapArray[col][ligne]] = playerColor2;
                        leds[mapArray[col + 1][ligne]] = playerColor2;
                        leds[mapArray[col + 2][ligne]] = playerColor2;
                        leds[mapArray[col + 3][ligne]] = playerColor2;
                        FastLED.show();
                        delay(500);
                        leds[mapArray[col][ligne]] = CRGB::Black;
                        leds[mapArray[col + 1][ligne]] = CRGB::Black;
                        leds[mapArray[col + 2][ligne]] = CRGB::Black;
                        leds[mapArray[col + 3][ligne]] = CRGB::Black;
                        FastLED.show();
                        delay(500);
                    }
                    reset();
                }
            }
        }
    }

    // check if there is a column
    for (int col = 0; col < 7; col++)
    {
        for (int ligne = 0; ligne < 3; ligne++)
        {
            if (gameArray[col][ligne] != 0)
            {
                int somme = gameArray[col][ligne] + gameArray[col][ligne + 1] + gameArray[col][ligne + 2] + gameArray[col][ligne + 3];
                if (somme == 4)
                {

                    while (digitalRead(btnValidPin))
                    {
                        leds[mapArray[col][ligne]] = playerColor1;
                        leds[mapArray[col][ligne + 1]] = playerColor1;
                        leds[mapArray[col][ligne + 2]] = playerColor1;
                        leds[mapArray[col][ligne + 3]] = playerColor1;
                        FastLED.show();
                        delay(500);
                        leds[mapArray[col][ligne]] = CRGB::Black;
                        leds[mapArray[col][ligne + 1]] = CRGB::Black;
                        leds[mapArray[col][ligne + 2]] = CRGB::Black;
                        leds[mapArray[col][ligne + 3]] = CRGB::Black;
                        FastLED.show();
                        delay(500);
                    }

                    reset();
                }
                else if (somme == 40)
                {
                    while (digitalRead(btnValidPin))
                    {
                        leds[mapArray[col][ligne]] = playerColor2;
                        leds[mapArray[col][ligne + 1]] = playerColor2;
                        leds[mapArray[col][ligne + 2]] = playerColor2;
                        leds[mapArray[col][ligne + 3]] = playerColor2;
                        FastLED.show();
                        delay(500);
                        leds[mapArray[col][ligne]] = CRGB::Black;
                        leds[mapArray[col][ligne + 1]] = CRGB::Black;
                        leds[mapArray[col][ligne + 2]] = CRGB::Black;
                        leds[mapArray[col][ligne + 3]] = CRGB::Black;
                        FastLED.show();
                        delay(500);
                    }

                    reset();
                }
            }
        }
    }

    // 3 check diagonal

    // 3.1 increasing diagonal
    for (int col = 0; col < 4; col++)
    {
        for (int ligne = 0; ligne < 3; ligne++)
        {
            if (gameArray[col][ligne] != 0)
            {
                int somme = gameArray[col][ligne] + gameArray[col + 1][ligne + 1] + gameArray[col + 2][ligne + 2] + gameArray[col + 3][ligne + 3];
                if (somme == 4)
                {

                    while (digitalRead(btnValidPin))
                    {
                        leds[mapArray[col][ligne]] = playerColor1;
                        leds[mapArray[col + 1][ligne + 1]] = playerColor1;
                        leds[mapArray[col + 2][ligne + 2]] = playerColor1;
                        leds[mapArray[col + 3][ligne + 3]] = playerColor1;
                        FastLED.show();
                        delay(500);
                        leds[mapArray[col][ligne]] = CRGB::Black;
                        leds[mapArray[col + 1][ligne + 1]] = CRGB::Black;
                        leds[mapArray[col + 2][ligne + 2]] = CRGB::Black;
                        leds[mapArray[col + 3][ligne + 3]] = CRGB::Black;
                        FastLED.show();
                        delay(500);
                    }

                    reset();
                }
                else if (somme == 40)
                {
                    while (digitalRead(btnValidPin))
                    {
                        leds[mapArray[col][ligne]] = playerColor2;
                        leds[mapArray[col + 1][ligne + 1]] = playerColor2;
                        leds[mapArray[col + 2][ligne + 2]] = playerColor2;
                        leds[mapArray[col + 3][ligne + 3]] = playerColor2;
                        FastLED.show();
                        delay(500);
                        leds[mapArray[col][ligne]] = CRGB::Black;
                        leds[mapArray[col + 1][ligne + 1]] = CRGB::Black;
                        leds[mapArray[col + 2][ligne + 2]] = CRGB::Black;
                        leds[mapArray[col + 3][ligne + 3]] = CRGB::Black;
                        FastLED.show();
                        delay(500);
                    }

                    reset();
                }
            }
        }
    }
    // 3.2 decreasing  diagonal
    for (int col = 0; col < 4; col++)
    {
        for (int ligne = 3; ligne < 6; ligne++)
        {
            if (gameArray[col][ligne] != 0)
            {
                int somme = gameArray[col][ligne] + gameArray[col + 1][ligne - 1] + gameArray[col + 2][ligne - 2] + gameArray[col + 3][ligne - 3];
                if (somme == 4)
                {

                    while (digitalRead(btnValidPin))
                    {
                        leds[mapArray[col][ligne]] = playerColor1;
                        leds[mapArray[col + 1][ligne - 1]] = playerColor1;
                        leds[mapArray[col + 2][ligne - 2]] = playerColor1;
                        leds[mapArray[col + 3][ligne - 3]] = playerColor1;
                        FastLED.show();
                        delay(500);
                        leds[mapArray[col][ligne]] = CRGB::Black;
                        leds[mapArray[col + 1][ligne - 1]] = CRGB::Black;
                        leds[mapArray[col + 2][ligne - 2]] = CRGB::Black;
                        leds[mapArray[col + 3][ligne - 3]] = CRGB::Black;
                        FastLED.show();
                        delay(500);
                    }

                    reset();
                }
                else if (somme == 40)
                {
                    while (digitalRead(btnValidPin))
                    {
                        leds[mapArray[col][ligne]] = playerColor2;
                        leds[mapArray[col + 1][ligne - 1]] = playerColor2;
                        leds[mapArray[col + 2][ligne - 2]] = playerColor2;
                        leds[mapArray[col + 3][ligne - 3]] = playerColor2;
                        FastLED.show();
                        delay(500);
                        leds[mapArray[col][ligne]] = CRGB::Black;
                        leds[mapArray[col + 1][ligne - 1]] = CRGB::Black;
                        leds[mapArray[col + 2][ligne - 2]] = CRGB::Black;
                        leds[mapArray[col + 3][ligne - 3]] = CRGB::Black;
                        FastLED.show();
                        delay(500);
                    }

                    reset();
                }
            }
        }
    }
}

void reset()
{
    for (int col = 0; col < 7; col++)
    {
        for (int ligne = 0; ligne < 6; ligne++)
        {
            gameArray[col][ligne] = 0;
        }
    }
    selectedColumn = 3;
    affice_tableau_jeu();
    ledColor = playerColor1;
    player = player1;
    delay(1000);
}

void affice_tableau_jeu()
{
    for (int col = 0; col < 7; col++)
    {
        for (int ligne = 0; ligne < 6; ligne++)
        {
            if (gameArray[col][ligne] == player1)
            {
                leds[mapArray[col][ligne]] = playerColor1;
            }
            else if (gameArray[col][ligne] == player2)
            {
                leds[mapArray[col][ligne]] = playerColor2;
            }
            else
            {
                leds[mapArray[col][ligne]] = CRGB::Black;
            }
        }
    }
    FastLED.show();
}

void listenButton()
{

    if (!digitalRead(rightPinBtn))
    {
        selectedColumn++;
        selectedColumn = selectedColumn % 7;
        delay(500);
    }
    else if (!digitalRead(leftPinBtn))
    {
        selectedColumn--;
        if (selectedColumn < 0)
        {
            selectedColumn = 6;
        }
        delay(500);
    }
    else if (!digitalRead(btnValidPin))
    {
        bool ajouer = false;
        for (int k = 0; k < 6; k++)
        {
            if (gameArray[selectedColumn][k] == 0 && ajouer == false)
            {
                ajouer = true;
                gameArray[selectedColumn][k] = player;
                if (player == player1)
                {
                    player = player2;
                }
                else
                {
                    player = player1;
                }
            }
        }
        delay(700);
    }
}

void colorChoice()
{
    if (player == player1)
    {
        ledColor = playerColor1;
    }
    else
    {
        ledColor = playerColor2;
    }
}

void display_pending_pawn()
{
    for (int i = 0; i < 7; i++)
    {
        leds[i] = CRGB::Black;
    }
    leds[selectedColumn] = ledColor;
    FastLED.show();
}
